/// 
/// There is a problem when you use a kendo control inside a tree.
/// Below the fix.
/// See url for more details: http://www.kendoui.com/forums/kendo-ui-web/treeview/kendo-menu-inside-a-tree.aspx
///

(function($, undefined) {

    function contentChild(filter) {
        return function(node) {
            var result = node.children(".k-animation-container");

            if (!result.length) {
                result = node;
            }

            return result.children(filter);
        };
    }
    
    var
        NODE = ".k-item",
        SELECT = "select",
        nodeContents = contentChild(".k-group,.k-content");

    kendo.ui.TreeView.fn._click = function(e) {
        var that = this,
            node = $(e.currentTarget),
            contents = nodeContents(node.closest(NODE)),
            href = node.attr("href"),
            shouldNavigate;

        if (href) {
            shouldNavigate = href == "#" || href.indexOf("#" + this.element.id + "-") >= 0;
        } else {
            shouldNavigate = contents.length && !contents.children().length;
        }

        if (shouldNavigate) {
            e.preventDefault();
        }

        if (!node.hasClass(".k-state-selected") && !that._trigger(SELECT, node)) {
            that.select(node);
        }
    };
})(window.kendo.jQuery);